package com.jscape.inet.ssh.protocol.v2.messages;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.util.net.connection.MessageConnection;

import static com.jscape.util.Parameters.assertNotNull;

/**
 * @author Alex Usun
 */
public class SshMsgChannelRequestSubsystem
        extends SshMsgChannelRequest<SshMsgChannelRequestSubsystem.Handler> {

    public final String subsystemName;

    public SshMsgChannelRequestSubsystem(int recipientChannel, boolean wantReply, String subsystemName) {
        super(recipientChannel, wantReply);

        assertNotNull(subsystemName);
        this.subsystemName = subsystemName;
    }

    @Override
    public Class handlerClass() {
        return Handler.class;
    }

    @Override
    public void accept(Handler handler, MessageConnection<Message> connection) {
        handler.handle(this, connection);
    }

    @Override
    public String toString() {
        return "SshMsgChannelRequestSubsystem {"
                + "recipientChannel=" + this.recipientChannel
                + ", wantReply=" + this.wantReply
                + ", subsystemName='" + this.subsystemName + '\''
                + '}';
    }

    public interface Handler
            extends Message.HandlerBase {

        void handle(SshMsgChannelRequestSubsystem message, MessageConnection<Message> connection);

    }
}
